<?php

namespace dgsoft\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for
 * ArrayOfVehicleLocationAdditionalDetailsTypeShuttleShuttleInfo ArrayType
 * @package Dg
 * @subpackage Arrays
 */
class DgArrayOfVehicleLocationAdditionalDetailsTypeShuttleShuttleInfo extends AbstractStructArrayBase
{
    /**
     * The ShuttleInfo
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \dgsoft\StructType\DgVehicleLocationAdditionalDetailsTypeShuttleShuttleInfo[]
     */
    public $ShuttleInfo;
    /**
     * Constructor method for
     * ArrayOfVehicleLocationAdditionalDetailsTypeShuttleShuttleInfo
     * @uses DgArrayOfVehicleLocationAdditionalDetailsTypeShuttleShuttleInfo::setShuttleInfo()
     * @param \dgsoft\StructType\DgVehicleLocationAdditionalDetailsTypeShuttleShuttleInfo[] $shuttleInfo
     */
    public function __construct(array $shuttleInfo = array())
    {
        $this
            ->setShuttleInfo($shuttleInfo);
    }
    /**
     * Get ShuttleInfo value
     * @return \dgsoft\StructType\DgVehicleLocationAdditionalDetailsTypeShuttleShuttleInfo[]|null
     */
    public function getShuttleInfo()
    {
        return $this->ShuttleInfo;
    }
    /**
     * Set ShuttleInfo value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgVehicleLocationAdditionalDetailsTypeShuttleShuttleInfo[] $shuttleInfo
     * @return \dgsoft\ArrayType\DgArrayOfVehicleLocationAdditionalDetailsTypeShuttleShuttleInfo
     */
    public function setShuttleInfo(array $shuttleInfo = array())
    {
        foreach ($shuttleInfo as $arrayOfVehicleLocationAdditionalDetailsTypeShuttleShuttleInfoShuttleInfoItem) {
            // validation for constraint: itemType
            if (!$arrayOfVehicleLocationAdditionalDetailsTypeShuttleShuttleInfoShuttleInfoItem instanceof \dgsoft\StructType\DgVehicleLocationAdditionalDetailsTypeShuttleShuttleInfo) {
                throw new \InvalidArgumentException(sprintf('The ShuttleInfo property can only contain items of \dgsoft\StructType\DgVehicleLocationAdditionalDetailsTypeShuttleShuttleInfo, "%s" given', is_object($arrayOfVehicleLocationAdditionalDetailsTypeShuttleShuttleInfoShuttleInfoItem) ? get_class($arrayOfVehicleLocationAdditionalDetailsTypeShuttleShuttleInfoShuttleInfoItem) : gettype($arrayOfVehicleLocationAdditionalDetailsTypeShuttleShuttleInfoShuttleInfoItem)), __LINE__);
            }
        }
        $this->ShuttleInfo = $shuttleInfo;
        return $this;
    }
    /**
     * Add item to ShuttleInfo value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgVehicleLocationAdditionalDetailsTypeShuttleShuttleInfo $item
     * @return \dgsoft\ArrayType\DgArrayOfVehicleLocationAdditionalDetailsTypeShuttleShuttleInfo
     */
    public function addToShuttleInfo(\dgsoft\StructType\DgVehicleLocationAdditionalDetailsTypeShuttleShuttleInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \dgsoft\StructType\DgVehicleLocationAdditionalDetailsTypeShuttleShuttleInfo) {
            throw new \InvalidArgumentException(sprintf('The ShuttleInfo property can only contain items of \dgsoft\StructType\DgVehicleLocationAdditionalDetailsTypeShuttleShuttleInfo, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ShuttleInfo[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \dgsoft\StructType\DgVehicleLocationAdditionalDetailsTypeShuttleShuttleInfo|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \dgsoft\StructType\DgVehicleLocationAdditionalDetailsTypeShuttleShuttleInfo|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \dgsoft\StructType\DgVehicleLocationAdditionalDetailsTypeShuttleShuttleInfo|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \dgsoft\StructType\DgVehicleLocationAdditionalDetailsTypeShuttleShuttleInfo|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \dgsoft\StructType\DgVehicleLocationAdditionalDetailsTypeShuttleShuttleInfo|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ShuttleInfo
     */
    public function getAttributeName()
    {
        return 'ShuttleInfo';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \dgsoft\ArrayType\DgArrayOfVehicleLocationAdditionalDetailsTypeShuttleShuttleInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
